#include "ansi_cs_table_defs.h"
#include "terminal.h"

// Insert Character
void cs_fn_ICH(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_insertGraphic(ctx, ' ', paramv[0]);
}

// Cursor Up
void cs_fn_CUU(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_cursorRel(ctx, DIR_UP, paramv[0], 0);
}

// Cursor Down / Vertical Position Relative
void cs_fn_CUD_VPR(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_cursorRel(ctx, DIR_DOWN, paramv[0], 0);
}

// Cursor Forward / Horizontal Position Relative
void cs_fn_CUF_HPR(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_cursorRel(ctx, DIR_FORWARD, paramv[0], 0);
}

// Cursor Back
void cs_fn_CUB(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_cursorRel(ctx, DIR_BACK, paramv[0], 0);
}

// Cursor Next Line
void cs_fn_CNL(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_cursorRel(ctx, DIR_DOWN, paramv[0], 0);
  Terminal_carriageReturn(ctx);
}

// Cursor Previous Line
void cs_fn_CPL(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_cursorRel(ctx, DIR_UP, paramv[0], 0);
  Terminal_carriageReturn(ctx);
}

// Cursor Horizontal Absolute
void cs_fn_CHA(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_cursorAbsH(ctx, paramv[0]);
}

// Cursor Position / Horizontal & Vertical Position
void cs_fn_CUP_HVP(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  paramv[0] -= 1; paramv[1] -= 1; // switch to 0-based addressing
  Terminal_cursorAbs(ctx, paramv[1], paramv[0]);
}

// Cursor Horizontal Forward Tab
void cs_fn_CHT(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_horizontalTab(ctx, paramv[0]);
}

// Erase in Display
void cs_fn_ED(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Erase in Line
void cs_fn_EL(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Insert Line
void cs_fn_IL(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Delete Line
void cs_fn_DL(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Erase in Field
void cs_fn_EF(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Erase in Area
void cs_fn_EA(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}



// Delete Character
void cs_fn_DCH(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Select Editing Extent
void cs_fn_SEE(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Cursor Position Report
void cs_fn_CPR(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Scroll Up (DEC Pan Down)
void cs_fn_SU(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Scroll Down (DEC Pan Up)
void cs_fn_SD(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Next Page
void cs_fn_NP(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Previous Page
void cs_fn_PP(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Cursor Tabulation Control
void cs_fn_CTC(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Erase Character
void cs_fn_ECH(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Cursor Vertical (Line) Tabulation
void cs_fn_CVT(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Cursor Backward Tabulation
void cs_fn_CBT(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_backTab(ctx, paramv[0]);
}

// Start Reversed String
void cs_fn_SRS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Parallel Texts
void cs_fn_PTX(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Start Directed String
void cs_fn_SDS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Select Implicit Movement Direction
void cs_fn_SIMD(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}


// Horizontal Position Absolute
void cs_fn_HPA(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_cursorAbsH(ctx, paramv[0]);
}

// Repeat
void cs_fn_REP(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Device Attributes
void cs_fn_DA(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Vertical Position Absolute
void cs_fn_VPA(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  Terminal_cursorAbsV(ctx, paramv[0]);
}

// Tabulation Clear
void cs_fn_TBC(void *ctx, int paramc, unsigned int *paramv)
{
  (void)paramc;
  switch (paramv[0]) {
  case 0: // Clear tab only at cursor
    Terminal_clearTab(ctx);
    break;
  case 3: // Clear all tabs
    Terminal_clearTabs(ctx);
    break;
  }
}

// Set Mode
void cs_fn_SM(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Media Copy
void cs_fn_MC(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Horizontal (Character) Position Backward
void cs_fn_HPB(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Vertical (Line) Position Backward
void cs_fn_VPB(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Reset Mode
void cs_fn_RM(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Graphic Rendition
void cs_fn_SGR(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Device Status Report
void cs_fn_DSR(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Define Area Qualification
void cs_fn_DAQ(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Scroll Left
void cs_fn_SL(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Scroll Right
void cs_fn_SR(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Graphic Size Modification
void cs_fn_GSM(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Graphic Size Selection
void cs_fn_GSS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Font Selection
void cs_fn_FNT(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Thin Space Specification
void cs_fn_TSS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Justify
void cs_fn_JFY(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Spacing Increment
void cs_fn_SPI(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Quad
void cs_fn_QUAD(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Select Size Unit
void cs_fn_SSU(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Page Format Selection
void cs_fn_PFS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Select Horizontal Spacing
void cs_fn_SHS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Select Vertical Spacing
void cs_fn_SVS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Identify Graphics Subrepertoire
void cs_fn_IGS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Horizontal Tabulation Set Absolute
void cs_fn_HTSA(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Identify Device Control String
void cs_fn_IDCS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}


// Page Position Absolute
void cs_fn_PPA(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Page Position Relative
void cs_fn_PPR(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Page Position Backward
void cs_fn_PPB(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Select Presentation Directions
void cs_fn_SPD(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Dimension Text Area
void cs_fn_DTA(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Line Home
void cs_fn_SLH(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Line Limit
void cs_fn_SLL(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Function Key
void cs_fn_FNK(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Select Print Quality & Rapidity
void cs_fn_SPQR(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Sheet Eject & Feed
void cs_fn_SEF(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Presentation Expand or Contract
void cs_fn_PEC(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Space Width
void cs_fn_SSW(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Additional Character Separation
void cs_fn_SACS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Select Alternative Presentation Variants
void cs_fn_SAPV(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Selective Tabulation
void cs_fn_STAB(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Graphic Character Combination
void cs_fn_GCC(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}


// Tabulation Aligned Trailing Edge
void cs_fn_TATE(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Tabulation Aligned Leading Edge
void cs_fn_TALE(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Tabulation Aligned Centered
void cs_fn_TAC(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Tabulation Centered on Character
void cs_fn_TCC(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Tabulation Stop Remove
void cs_fn_TSR(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Character Orientation
void cs_fn_SCO(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Reduced Character Separation
void cs_fn_SRCS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Character Spacing
void cs_fn_SCS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Line Spacing
void cs_fn_SLS(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Page Home
void cs_fn_SPH(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Set Page Limit
void cs_fn_SPL(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}

// Select Character Path
void cs_fn_SCP(void *ctx, int paramc, unsigned int *paramv)
{
  return;
}
