#include "ansi_cs_table_defs.h"

/*
 * No Intermediate Character, Final Character Cols 4 - 7
 */

/* Final Character Col 4 */

CE cs_ICH = {{"Insert Character",              ENTRY_CS}, "ICH", 1, {1},    cs_fn_ICH};
CE cs_CUU = {{"Cursor Up",                     ENTRY_CS}, "CUU", 1, {1},    cs_fn_CUU};
CE cs_CUD = {{"Cursor Down",                   ENTRY_CS}, "CUD", 1, {1},    cs_fn_CUD_VPR};
CE cs_CUF = {{"Cursor Forward",                ENTRY_CS}, "CUF", 1, {1},    cs_fn_CUF_HPR};
CE cs_CUB = {{"Cursor Back",                   ENTRY_CS}, "CUB", 1, {1},    cs_fn_CUB};
CE cs_CNL = {{"Cursor Next Line",              ENTRY_CS}, "CNL", 1, {1},    cs_fn_CNL};
CE cs_CPL = {{"Cursor Previous Line",          ENTRY_CS}, "CNL", 1, {1},    cs_fn_CPL};
CE cs_CHA = {{"Cursor Horizontal Absolute",    ENTRY_CS}, "CHA", 1, {1},    cs_fn_CHA};
CE cs_CUP = {{"Cursor Position",               ENTRY_CS}, "CUP", 2, {1, 1}, cs_fn_CUP_HVP};
CE cs_CHT = {{"Cursor Horizontal Forward Tab", ENTRY_CS}, "CHT", 1, {1},    cs_fn_CHT};
CE cs_ED  = {{"Erase in Display",              ENTRY_CS}, "ED",  1, {1},    cs_fn_ED};
CE cs_EL  = {{"Erase in Line",                 ENTRY_CS}, "ED",  1, {1},    cs_fn_EL};
CE cs_IL  = {{"Insert Line",                   ENTRY_CS}, "IL",  1, {1},    cs_fn_IL};
CE cs_DL  = {{"Delete Line",                   ENTRY_CS}, "DL",  1, {1},    cs_fn_DL};
CE cs_EF  = {{"Erase in Field",                ENTRY_CS}, "EF",  1, {1},    cs_fn_EF};
CE cs_EA  = {{"Erase in Area",                 ENTRY_CS}, "EA",  1, {1},    cs_fn_EA};

struct table_col CS_NoI_4 = {{
  &cs_ICH.head, &cs_CUU.head, &cs_CUD.head, &cs_CUF.head,
  &cs_CUB.head, &cs_CNL.head, &cs_CPL.head, &cs_CHA.head,
  &cs_CUP.head, &cs_CHT.head, &cs_ED.head,  &cs_EL.head,
  &cs_IL.head,  &cs_DL.head,  &cs_EF.head,  &cs_EA.head
}};

/* Final Character Col 5 */

CE cs_DCH = {{"Delete Character",              ENTRY_CS}, "DCH", 1, {1},    cs_fn_DCH};
CE cs_SEE = {{"Select Editing Extent",         ENTRY_CS}, "SEE", 1, {1},    cs_fn_SEE};
CE cs_CPR = {{"Cursor Position Report",        ENTRY_CS}, "CPR", 1, {1},    cs_fn_CPR};
CE cs_SU  = {{"Scroll Up (DEC Pan Down)",      ENTRY_CS}, "SU",  1, {1},    cs_fn_SU};
CE cs_SD  = {{"Scroll Down (DEC Pan Up)",      ENTRY_CS}, "SD",  1, {1},    cs_fn_SD};
CE cs_NP  = {{"Next Page",                     ENTRY_CS}, "NP",  1, {1},    cs_fn_NP};
CE cs_PP  = {{"Previous Page",                 ENTRY_CS}, "PP",  1, {1},    cs_fn_PP};
CE cs_CTC = {{"Cursor Tabulation Control",     ENTRY_CS}, "CTC", 1, {1},    cs_fn_CTC};
CE cs_ECH = {{"Erase Character",               ENTRY_CS}, "ECH", 1, {1},    cs_fn_ECH};
CE cs_CVT = {{"Cursor Vertical Tabulation",    ENTRY_CS}, "CVT", 1, {1},    cs_fn_CVT};
CE cs_CBT = {{"Cursor Backward Tabulation",    ENTRY_CS}, "CBT", 1, {1},    cs_fn_CBT};
CE cs_SRS = {{"Start Reversed String",         ENTRY_CS}, "SRS", 1, {1},    cs_fn_SRS};
CE cs_PTX = {{"Parallel Texts",                ENTRY_CS}, "PTX", 1, {1},    cs_fn_PTX};
CE cs_SDS = {{"Start Directed String",         ENTRY_CS}, "SDS", 1, {1},    cs_fn_SDS};
CE cs_SIMD= {{"Select Implicit Movement Dir",  ENTRY_CS}, "SIMD",1, {1},    cs_fn_SIMD};
// Blank

struct table_col CS_NoI_5 = {{
    &cs_DCH.head, &cs_SEE.head, &cs_CPR.head, &cs_SU.head,
    &cs_SD.head,  &cs_NP.head,  &cs_PP.head,  &cs_CTC.head,
    &cs_ECH.head, &cs_CVT.head, &cs_CBT.head, &cs_SRS.head,
    &cs_PTX.head, &cs_SDS.head, &cs_SIMD.head, 0
}};

/* Final Character Col 6 */

CE cs_HPA = {{"Horizontal Position Absolute",  ENTRY_CS}, "HPA", 1, {1},    cs_fn_HPA};
CE cs_HPR = {{"Horizontal Position Relative",  ENTRY_CS}, "HPR", 1, {1},    cs_fn_CUF_HPR};
CE cs_REP = {{"Repeat",                        ENTRY_CS}, "REP", 1, {1},    cs_fn_REP};
CE cs_DA  = {{"Device Attributes",             ENTRY_CS}, "DA",  1, {1},    cs_fn_DA};
CE cs_VPA = {{"Vertical Position Absolute",    ENTRY_CS}, "VPA", 1, {1},    cs_fn_VPA};
CE cs_VPR = {{"Vertical Position Relative",    ENTRY_CS}, "VPR", 1, {1},    cs_fn_CUD_VPR};
CE cs_HVP = {{"Horizontal & Vertical Position",ENTRY_CS}, "HVP", 2, {1, 1}, cs_fn_CUP_HVP};
CE cs_TBC = {{"Tabulation Clear",              ENTRY_CS}, "TBC", 1, {1},    cs_fn_TBC};
CE cs_SM  = {{"Set Mode",                      ENTRY_CS}, "SM",  1, {1},    cs_fn_SM};
CE cs_MC  = {{"Media Copy",                    ENTRY_CS}, "MC",  1, {1},    cs_fn_MC};
CE cs_HPB = {{"Horizontal Position Backward",  ENTRY_CS}, "HPB", 1, {1},    cs_fn_HPB};
CE cs_VPB = {{"Vertical Position Backward",    ENTRY_CS}, "VPB", 1, {1},    cs_fn_VPB};
CE cs_RM  = {{"Reset Mode",                    ENTRY_CS}, "RM",  1, {1},    cs_fn_RM};
CE cs_SGR = {{"Set Graphic Rendition",         ENTRY_CS}, "SGR", 1, {1},    cs_fn_SGR};
CE cs_DSR = {{"Device Status Report",          ENTRY_CS}, "DSR", 1, {1},    cs_fn_DSR};
CE cs_DAQ = {{"Define Area Qualification",     ENTRY_CS}, "DAQ", 1, {1},    cs_fn_DAQ};

struct table_col CS_NoI_6 = {{
    &cs_HPA.head, &cs_HPR.head, &cs_REP.head, &cs_DA.head,
    &cs_VPA.head, &cs_VPR.head, &cs_HVP.head, &cs_TBC.head,
    &cs_SM.head,  &cs_MC.head,  &cs_HPB.head, &cs_VPB.head,
    &cs_RM.head,  &cs_SGR.head, &cs_DSR.head, &cs_DAQ.head
}};

/* Final Character Col 7 (DEC Private) */

CE cs_DECSSL  = {{"Select Set-Up Language",     ENTRY_CS}, "DECSSL", 1, {1},    cs_fn_DECSSL};
CE cs_DECLL   = {{"Load LEDs",                  ENTRY_CS}, "DECLL", 1, {1},    cs_fn_DECLL};
CE cs_DECSTBM = {{"Set Top & Bottom Margins",   ENTRY_CS}, "DECSTBM", 1, {1},    cs_fn_DECSTBM};
CE cs_DECSLRM = {{"Set Left & Right Margins",   ENTRY_CS}, "DECSLRM", 1, {1},    cs_fn_DECSLRM};
CE cs_DECSLPP = {{"Set Lines per Physical Page",ENTRY_CS}, "DECSLPP", 1, {1},    cs_fn_DECSLPP};
// Blank
// Blank
// Blank
CE cs_DECREQTPARM = {{"Request Terminal Parameters", ENTRY_CS}, "DECREQTPARM", 1, {1},cs_fn_DECREQTPARM};
CE cs_DECTST = {{"Invoke Confidence Test",      ENTRY_CS}, "DECTST", 1, {1},    cs_fn_DECTST};
// Blank
// Blank
CE cs_DECTTC = {{"Select Transmit Termination Character", ENTRY_CS}, "DECTTC", 1, {1},    cs_fn_DECTTC};
CE cs_DECPRO = {{"Set Protected Field Attributes", ENTRY_CS}, "DECPRO", 1, {1},    cs_fn_DECPRO};
CE cs_DECFNK = {{"Function Key", ENTRY_CS}, "DECFNK", 1, {1},    cs_fn_DECFNK};

struct table_col CS_NoI_7_DEC = {{
    &cs_DECSSL.head, &cs_DECLL.head, &cs_DECSTBM.head, &cs_DECSLRM.head,
    &cs_DECSLPP.head,0             , 0,                0,
    &cs_DECREQTPARM.head, &cs_DECTST.head, 0,          0,
    &cs_DECTTC.head, &cs_DECPRO.head,&cs_DECFNK.head,  0
}};

struct control_seq_final_table CS_NoI = {{ &CS_NoI_4, &CS_NoI_5, &CS_NoI_6, &CS_NoI_7_DEC }};

/*
 * Intermediate Character 0, Final Character Cols 4 - 7
 */

/* Final Character Col 4 */

CE cs_SL  = {{"Scroll Left",                   ENTRY_CS}, "SL",  1, {1},    cs_fn_SL};
CE cs_SR  = {{"Scroll Right",                  ENTRY_CS}, "SR",  1, {1},    cs_fn_SR};
CE cs_GSM = {{"Graphic Size Modification",     ENTRY_CS}, "GSM", 1, {1},    cs_fn_GSM};
CE cs_GSS = {{"Graphic Size Selection",        ENTRY_CS}, "GSS", 1, {1},    cs_fn_GSS};
CE cs_FNT = {{"Font Selection",                ENTRY_CS}, "FNT", 1, {1},    cs_fn_FNT};
CE cs_TSS = {{"Thin Space Specification",      ENTRY_CS}, "TSS", 1, {1},    cs_fn_TSS};
CE cs_JFY = {{"Justify",                       ENTRY_CS}, "JFY", 1, {1},    cs_fn_JFY};
CE cs_SPI = {{"Spacing Increment",             ENTRY_CS}, "SPI", 1, {1},    cs_fn_SPI};
CE cs_QUAD= {{"Quad",                          ENTRY_CS}, "QUAD",1, {1},    cs_fn_QUAD};
CE cs_SSU = {{"Select Size Unit",              ENTRY_CS}, "SSU", 1, {1},    cs_fn_SSU};
CE cs_PFS = {{"Page Format Selection",         ENTRY_CS}, "PFS", 1, {1},    cs_fn_PFS};
CE cs_SHS = {{"Select Horizontal Spacing",     ENTRY_CS}, "SHS", 1, {1},    cs_fn_SHS};
CE cs_SVS = {{"Select Vertical Spacing",       ENTRY_CS}, "SVS", 1, {1},    cs_fn_SVS};
CE cs_IGS = {{"Identify Graphics Subrep.",     ENTRY_CS}, "IGS", 1, {1},    cs_fn_IGS};
CE cs_HTSA= {{"Horizontal Tabulation Set Abs", ENTRY_CS}, "HTSA",1, {1},    cs_fn_HTSA};
CE cs_IDCS= {{"Identify Device Control String",ENTRY_CS}, "IDCS",1, {1},    cs_fn_IDCS};

struct table_col CS_I0_4 = {{
    &cs_SL.head,  &cs_SR.head,  &cs_GSM.head, &cs_GSS.head,
    &cs_FNT.head, &cs_TSS.head, &cs_JFY.head, &cs_SPI.head,
    &cs_QUAD.head,&cs_SSU.head, &cs_PFS.head, &cs_SHS.head,
    &cs_SVS.head, &cs_IGS.head, &cs_HTSA.head,&cs_IDCS.head
}};

/* Final Character Col 5 */

CE cs_PPA = {{"Page Position Absolute",        ENTRY_CS}, "PPA", 1, {1},    cs_fn_PPA};
CE cs_PPR = {{"Page Position Relative",        ENTRY_CS}, "PPR", 1, {1},    cs_fn_PPR};
CE cs_PPB = {{"Page Position Backward",        ENTRY_CS}, "PPB", 1, {1},    cs_fn_PPB};
CE cs_SPD = {{"Select Presentation Directions",ENTRY_CS}, "SPD", 1, {1},    cs_fn_SPD};
CE cs_DTA = {{"Dimension Text Area",           ENTRY_CS}, "DTA", 1, {1},    cs_fn_DTA};
CE cs_SLH = {{"Set Line Home",                 ENTRY_CS}, "SLH", 1, {1},    cs_fn_SLH};
CE cs_SLL = {{"Set Line Limit",                ENTRY_CS}, "SLL", 1, {1},    cs_fn_SLL};
CE cs_FNK = {{"Function Key",                  ENTRY_CS}, "FNK", 1, {1},    cs_fn_FNK};
CE cs_SPQR= {{"Select Print Quality&Rapidity", ENTRY_CS}, "SPQR",1, {1},    cs_fn_SPQR};
CE cs_SEF = {{"Sheet Eject & Feed",            ENTRY_CS}, "SEF", 1, {1},    cs_fn_SEF};
CE cs_PEC = {{"Pres Expand or Contract",       ENTRY_CS}, "PEC", 1, {1},    cs_fn_PEC};
CE cs_SSW = {{"Set Space Width",               ENTRY_CS}, "SSW", 1, {1},    cs_fn_SSW};
CE cs_SACS= {{"Set Addl Character Separation", ENTRY_CS}, "SACS",1, {1},    cs_fn_SACS};
CE cs_SAPV= {{"Select Alt Pres Variants",      ENTRY_CS}, "SAPV",1, {1},    cs_fn_SAPV};
CE cs_STAB= {{"Selective Tabulation",          ENTRY_CS}, "STAB",1, {1},    cs_fn_STAB};
CE cs_GCC = {{"Graphic Character Combination", ENTRY_CS}, "GCC", 1, {1},    cs_fn_GCC};

struct table_col CS_I0_5 = {{
    &cs_PPA.head, &cs_PPR.head, &cs_PPB.head, &cs_SPD.head,
    &cs_DTA.head, &cs_SLH.head, &cs_SLL.head, &cs_FNK.head,
    &cs_SPQR.head,&cs_SEF.head, &cs_PEC.head, &cs_SSW.head,
    &cs_SACS.head,&cs_SAPV.head,&cs_STAB.head,&cs_GCC.head
}};

/* Final Character Col 6 */

CE cs_TATE= {{"Tab Aligned Trailing Edge",     ENTRY_CS}, "TATE",1, {1},    cs_fn_TATE};
CE cs_TALE= {{"Tab Aligned Leading Edge",      ENTRY_CS}, "TALE",1, {1},    cs_fn_TALE};
CE cs_TAC = {{"Tab Aligned Centered",          ENTRY_CS}, "TAC", 1, {1},    cs_fn_TAC};
CE cs_TCC = {{"Tab Centered on Character",     ENTRY_CS}, "TCC", 1, {1},    cs_fn_TCC};
CE cs_TSR = {{"Tab Stop Remove",               ENTRY_CS}, "TSR", 1, {1},    cs_fn_TSR};
CE cs_SCO = {{"Set Character Orientation",     ENTRY_CS}, "SCO", 1, {1},    cs_fn_SCO};
CE cs_SRCS= {{"Set Reduced Char Separation",   ENTRY_CS}, "SRCS",1, {1},    cs_fn_SRCS};
CE cs_SCS = {{"Set Character Spacing",         ENTRY_CS}, "SCS", 1, {1},    cs_fn_SCS};
CE cs_SLS = {{"Set Line Spacing",              ENTRY_CS}, "SLS", 1, {1},    cs_fn_SLS};
CE cs_SPH = {{"Set Page Home",                 ENTRY_CS}, "SPH", 1, {1},    cs_fn_SPH};
CE cs_SPL = {{"Set Page Limit",                ENTRY_CS}, "SPL", 1, {1},    cs_fn_SPL};
CE cs_SCP = {{"Select Character Path",         ENTRY_CS}, "SCP", 1, {1},    cs_fn_SCP};

struct table_col CS_I0_6 = {{
    &cs_TATE.head,&cs_TALE.head,&cs_TAC.head, &cs_TCC.head,
    &cs_TSR.head, &cs_SCO.head, &cs_SRCS.head,&cs_SCS.head,
    &cs_SLS.head, &cs_SPH.head, &cs_SPL.head, &cs_SCP.head,
    0,            0,            0,            0
}};

/* Final Character Col 7 (DEC Private) */

CE cs_DECSSCLS= {{"Set Scroll Speed", ENTRY_CS}, "DECSSCLS", 1, {1},    cs_fn_DECSSCLS};
CE cs_DECSCUSR= {{"Set Cursor Style", ENTRY_CS}, "DECSCUSR", 1, {1},    cs_fn_DECSCUSR};
CE cs_DECSKCV = {{"Set Keyclick Volume", ENTRY_CS}, "DECSKCV", 1, {1},    cs_fn_DECSKCV};
// Blank
CE cs_DECSWBV = {{"Set Warning Bell Volume", ENTRY_CS}, "DECSWBV", 1, {1},    cs_fn_DECSWBV};
CE cs_DECSMBV = {{"Set Margin Bell Volume", ENTRY_CS}, "DECSMBV", 1, {1},    cs_fn_DECSMBV};
CE cs_DECSLCK = {{"Set Lock Key Style", ENTRY_CS}, "DECSLCK", 1, {1},    cs_fn_DECSLCK};
// Blank
// Blank
// Blank
// Blank
// Blank
// Blank
CE cs_DECKBD  = {{"Keyboard Language Selection", ENTRY_CS}, "DECKBD", 1, {1},    cs_fn_DECKBD};
CE cs_DECTME  = {{"Terminal Mode Emulation", ENTRY_CS}, "DECTME", 1, {1},    cs_fn_DECTME};

struct table_col CS_I0_7_DEC = {{
    &cs_DECSSCLS.head, &cs_DECSCUSR.head, &cs_DECSKCV.head, 0,
    &cs_DECSWBV.head,  &cs_DECSMBV.head,  &cs_DECSLCK.head, 0,
    0,                 0,                 0,                0,
    0,                 &cs_DECKBD.head,   &cs_DECTME.head,  0
}};

struct control_seq_final_table CS_I0 = {{ &CS_I0_4, &CS_I0_5, &CS_I0_6, &CS_I0_7_DEC }};

/*
 * Intermediate Character 1, Final Character Cols 4 - 7
 */

/* No defined functions for Cols 4-6 */

/* Final Character Col 7 (DEC Private) */

CE cs_DECSTR = {{"Soft Terminal Reset", ENTRY_CS}, "DECSTR", 1, {1},    cs_fn_DECSTR};

struct table_col CS_I1_7_DEC = {{
    &cs_DECSTR.head, 0, 0, 0,
    0              , 0, 0, 0,
    0              , 0, 0, 0,
    0              , 0, 0, 0
}};

struct control_seq_final_table CS_I1 = {{ 0, 0, 0, &CS_I1_7_DEC }};

/*
 * Intermediate Character 2, Final Character Cols 4 - 7
 */

/* No defined functions for Cols 4-6 */

/* Final Character Col 7 (DEC Private) */

CE cs_DECSCL  = {{"Set Conformance Level", ENTRY_CS}, "DECSCL", 1, {1}, cs_fn_DECSCL};
CE cs_DECSCA  = {{"Select Character Attributes", ENTRY_CS}, "DECSCA", 1, {1}, cs_fn_DECSCA};
// Blank
// Blank
CE cs_DECSRFR = {{"Select Refresh Rate", ENTRY_CS}, "DECSRFR", 1, {1},    cs_fn_DECSRFR};
CE cs_DECSTRL = {{"Set Transmit Rate Limit", ENTRY_CS}, "DECSTRL", 1, {1},cs_fn_DECSTRL};
CE cs_DECRQDE = {{"Request Device Extent", ENTRY_CS}, "DECRQDE", 1, {1},  cs_fn_DECRQDE};
CE cs_DECRPDE = {{"Report Device Extent", ENTRY_CS}, "DECRPDE", 1, {1},   cs_fn_DECRPDE};

struct table_col CS_I2_7_DEC = {{
    &cs_DECSCL.head,  &cs_DECSCA.head,  0,                0,
    &cs_DECSRFR.head, &cs_DECSTRL.head, &cs_DECRQDE.head, &cs_DECRPDE.head,
    0,                0,                0,                0,
    0,                0,                0,                0
}};

struct control_seq_final_table CS_I2 = {{ 0, 0, 0, &CS_I2_7_DEC }};

/*
 * No Intermediate Character 3 functions
 */

// struct control_seq_final_table CS_I3 = {{ 0, 0, 0, 0 }};

/*
 * Intermediate Character 4, Final Character Cols 4 - 7
 */

/* No defined functions for Cols 4-6 */

/* Final Character Col 7 (DEC Private) */

CE cs_DECRQM  = {{"Request Mode Settings", ENTRY_CS}, "DECRQM", 1, {1}, cs_fn_DECRQM};
CE cs_DECSDDT = {{"Select Disconnect Delay Time", ENTRY_CS}, "DECSDDT", 1, {1}, cs_fn_DECSDDT};
CE cs_DECCARA = {{"Change Attributes in Rectangular Area", ENTRY_CS}, "DECCARA", 1, {1}, cs_fn_DECCARA};
CE cs_DECSPRTT= {{"Select Printer Type", ENTRY_CS}, "DECSPRTT", 1, {1}, cs_fn_DECSPRTT};
CE cs_DECRARA = {{"Reverse Attributes in Rectangular Area", ENTRY_CS}, "DECRARA", 1, {1}, cs_fn_DECRARA};
CE cs_DECRQTSR= {{"Request Terminal State Report", ENTRY_CS}, "DECRQTSR", 1, {1}, cs_fn_DECRQTSR};
CE cs_DECCRA  = {{"Copy Rectangular Area", ENTRY_CS}, "DECCRA", 1, {1}, cs_fn_DECCRA};
CE cs_DECRQPSR= {{"Request Presentation State Report", ENTRY_CS}, "DECRQPSR", 1, {1}, cs_fn_DECRQPSR};
CE cs_DECFRA  = {{"Fill Rectangular Area", ENTRY_CS}, "DECFRA", 1, {1}, cs_fn_DECFRA};
CE cs_DECRPM  = {{"Report Mode Settings", ENTRY_CS}, "DECRPM", 1, {1}, cs_fn_DECRPM};
CE cs_DECERA  = {{"Erase Rectangular Area", ENTRY_CS}, "DECERA", 1, {1}, cs_fn_DECERA};
CE cs_DECSERA = {{"Selective Erase Rectangular Area", ENTRY_CS}, "DECSERA", 1, {1}, cs_fn_DECSERA};
CE cs_DECSCPP = {{"Set Columns Per Page", ENTRY_CS}, "DECSCPP", 1, {1}, cs_fn_DECSCPP};
CE cs_DECSASD = {{"Select Active Status Display", ENTRY_CS}, "DECSASD", 1, {1}, cs_fn_DECSASD};
CE cs_DECSSDT = {{"Select Status Display Type", ENTRY_CS}, "DECSSDT", 1, {1}, cs_fn_DECSSDT};

struct table_col CS_I4_7_DEC = {{
    &cs_DECRQM.head,  &cs_DECSDDT.head,  &cs_DECCARA.head, &cs_DECSPRTT.head,
    &cs_DECRARA.head, &cs_DECRQTSR.head, &cs_DECCRA.head,  &cs_DECRQPSR.head,
    &cs_DECFRA.head,  &cs_DECRPM.head,   &cs_DECERA.head,  &cs_DECSERA.head,
    &cs_DECSCPP.head, &cs_DECSASD.head,  &cs_DECSSDT.head, 0
}};

struct control_seq_final_table CS_I4 = {{ 0, 0, 0, &CS_I4_7_DEC }};

/*
 * No Intermediate Character 5 functions
 */

// struct control_seq_final_table CS_I5 = {{ 0, 0, 0, 0 }};

/*
 * Intermediate Character 6, Final Character Cols 4 - 7
 */

/* No defined functions for Cols 4-6 */

/* Final Character Col 7 (DEC Private) */

// Blank
// Blank
// Blank
// Blank
// Blank
CE cs_DECRQUPSS= {{"Request User-Preferred Supplemental Set", ENTRY_CS}, "DECRQUPSS", 1, {1},cs_fn_DECRQUPSS};
// Blank
CE cs_DECLRP   = {{"Locator Report", ENTRY_CS}, "DECLRP", 1, {1}, cs_fn_DECLRP};
CE cs_DECES    = {{"Enable Session", ENTRY_CS}, "DECES", 1, {1},  cs_fn_DECES};

struct table_col CS_I6_7_DEC = {{
    0,             0,                  0, 0,
    0,             &cs_DECRQUPSS.head, 0, &cs_DECLRP.head,
    &cs_DECES.head,0,                  0, 0,
    0,             0,                  0, 0
}};

struct control_seq_final_table CS_I6 = {{ 0, 0, 0, &CS_I6_7_DEC }};

/*
 * Intermediate Character 7, Final Character Cols 4 - 7
 */

/* No defined functions for Cols 4-6 */

/* Final Character Col 7 (DEC Private) */

//blank
//blank
//blank
CE cs_DECTLTC= {{"Transmit Line Termination Characters", ENTRY_CS}, "DECTLTC", 1, {1},cs_fn_DECTLTC};
//blank
//blank
//blank
CE cs_DECEFR = {{"Enable Filter Rectangle",  ENTRY_CS}, "DECEFR", 1, {1}, cs_fn_DECEFR};
//blank
//blank
CE cs_DECELR = {{"Enable Locator Reports",   ENTRY_CS}, "DECELR", 1, {1}, cs_fn_DECELR};
CE cs_DECSLE = {{"Select Locator Events",    ENTRY_CS}, "DECSLE", 1, {1}, cs_fn_DECSLE};
CE cs_DECRQLP= {{"Request Locator Position", ENTRY_CS}, "DECRQLP", 1, {1},cs_fn_DECRQLP};
CE cs_DECIC  = {{"Insert Column",            ENTRY_CS}, "DECIC", 1, {1},  cs_fn_DECIC};
CE cs_DECDC  = {{"Delete Column",            ENTRY_CS}, "DECDC", 1, {1},  cs_fn_DECDC};

struct table_col CS_I7_7_DEC = {{
    0,                0,              0,               &cs_DECTLTC.head,
    0,                0,              0,               &cs_DECEFR.head,
    0,                0,              &cs_DECELR.head, &cs_DECSLE.head,
    &cs_DECRQLP.head, &cs_DECIC.head, &cs_DECDC.head,  0
}};

struct control_seq_final_table CS_I7 = {{ 0, 0, 0, &CS_I7_7_DEC }};

/*
 * No Intermediate Character 8 functions
 */

// struct control_seq_final_table CS_I8 = {{ 0, 0, 0, 0 }};

/*
 * Intermediate Character 9, Final Character Cols 4 - 7
 */

/* No defined functions for Cols 4-6 */

/* Final Character Col 7 (DEC Private) */

CE cs_DECSPDT = {{"Select Digital Printed Data Type",   ENTRY_CS}, "DECSPDT", 1, {1}, cs_fn_DECSPDT};
//blank
//blank
//blank
//blank
//blank
//blank
//blank
//blank
//blank
//blank
//blank
//blank
CE cs_DECSTGLT= {{"Select Text/Graphics Look-Up Table", ENTRY_CS}, "DECSTGLT", 1, {1},cs_fn_DECSTGLT};

struct table_col CS_I9_7_DEC = {{
    &cs_DECSPDT.head, 0,                 0, 0,
    0,                0,                 0, 0,
    0,                0,                 0, 0,
    0,                &cs_DECSTGLT.head, 0, 0
}};

struct control_seq_final_table CS_I9 = {{ 0, 0, 0, &CS_I9_7_DEC }};

/*
 * Intermediate Character 10, Final Character Cols 4 - 7
 */

/* No defined functions for Cols 4-6 */

/* Final Character Col 7 (DEC Private) */

CE cs_DECSPPCS= {{"Select ProPrinter Character Set",ENTRY_CS}, "DECSPPCS", 1, {1},cs_fn_DECSPPCS};
CE cs_DECSRC  = {{"Secure Reset Confirmation",      ENTRY_CS}, "DECSRC", 1, {1}, cs_fn_DECSRC};
CE cs_DECSCS  = {{"Select Communication Speed",     ENTRY_CS}, "DECSCS", 1, {1}, cs_fn_DECSCS};
CE cs_DECSFC  = {{"Select Flow Control",            ENTRY_CS}, "DECSFC", 1, {1}, cs_fn_DECSFC};
//blank
CE cs_DECSCP  = {{"Select Communication Port",      ENTRY_CS}, "DECSCP", 1, {1}, cs_fn_DECSCP};
//blank
//blank
CE cs_DECSACE = {{"Select Attribute Change Extent", ENTRY_CS}, "DECSACE", 1, {1},cs_fn_DECSACE};
CE cs_DECRQCRA= {{"Request Checksum of Rectangular Area", ENTRY_CS}, "DECRQCRA", 1, {1},cs_fn_DECRQCRA};
CE cs_DECINVM = {{"Invoke Macro",                   ENTRY_CS}, "DECINVM", 1, {1},cs_fn_DECINVM};
CE cs_DECMSR  = {{"Macro Space Report",             ENTRY_CS}, "DECMSR", 1, {1}, cs_fn_DECMSR};
CE cs_DECSNLS = {{"Select Number of Lines per Screen", ENTRY_CS}, "DECSNLS", 1, {1},cs_fn_DECSNLS};
CE cs_DECLFKC = {{"Local Function Key Control",     ENTRY_CS}, "DECLFKC", 1, {1},cs_fn_DECLFKC};

struct table_col CS_I10_7_DEC = {{
    &cs_DECSPPCS.head, &cs_DECSRC.head,   &cs_DECSCS.head,  &cs_DECSFC.head,
    0,                 &cs_DECSCP.head,   0,                0,
    &cs_DECSACE.head,  &cs_DECRQCRA.head, &cs_DECINVM.head, &cs_DECMSR.head,
    &cs_DECSNLS.head,  &cs_DECLFKC.head,  0,                0
}};

struct control_seq_final_table CS_I10 = {{ 0, 0, 0, &CS_I10_7_DEC }};

/*
 * Intermediate Character 11, Final Character Cols 4 - 7
 */

/* No defined functions for Cols 4-6 */

/* Final Character Col 7 (DEC Private) */

CE cs_DECSR    = {{"Secure Reset",           ENTRY_CS}, "DECSR", 1, {1},  cs_fn_DECSR};
CE cs_DECELF   = {{"Enable Local Functions", ENTRY_CS}, "DECELF", 1, {1}, cs_fn_DECELF};
CE cs_DECSMKR  = {{"Select Modifier Key Reporting", ENTRY_CS}, "DECSMKR", 1, {1},cs_fn_DECSMKR};
//blank
//blank
//blank
//blank
CE cs_DECSPP   = {{"Select Port Parameter", ENTRY_CS}, "DECSPP", 1, {1}, cs_fn_DECSPP};
CE cs_DECRQPKFM= {{"Program Key Free Memory Inquiry", ENTRY_CS}, "DECRQPKFM", 1, {1},cs_fn_DECRQPKFM};
CE cs_DECPKFMR = {{"Program Key Free Memory Report", ENTRY_CS}, "DECPKFMR", 1, {1},  cs_fn_DECPKFMR};
CE cs_DECPKA   = {{"Program Key Action",    ENTRY_CS}, "DECPKA", 1, {1}, cs_fn_DECPKA};

struct table_col CS_I11_7_DEC = {{
    &cs_DECSR.head,     &cs_DECELF.head,   &cs_DECSMKR.head, 0,
    0,                  0,                 0,                &cs_DECSPP.head,
    &cs_DECRQPKFM.head, &cs_DECPKFMR.head, &cs_DECPKA.head,  0,
    0,                  0,                 0,                0
}};

struct control_seq_final_table CS_I11 = {{ 0, 0, 0, &CS_I11_7_DEC }};

/*
 * Intermediate Character 12, Final Character Cols 4 - 7
 */

/* No defined functions for Cols 4-6 */

/* Final Character Col 7 (DEC Private) */

CE cs_DECLTOD= {{"Load Time of Day",         ENTRY_CS}, "DECLTOD", 1, {1}, cs_fn_DECLTOD};
CE cs_DECTID = {{"Select Terminal ID",       ENTRY_CS}, "DECTID", 1, {1},  cs_fn_DECTID};
//blank
//blank
//blank
CE cs_DECRQKT= {{"Key Type Inquiry",         ENTRY_CS}, "DECRQKT", 1, {1}, cs_fn_DECRQKT};
CE cs_DECRPKT= {{"Report Key Type",          ENTRY_CS}, "DECRPKT", 1, {1}, cs_fn_DECRPKT};
CE cs_DECRQKD= {{"Request Key Definition",   ENTRY_CS}, "DECRQKD", 1, {1}, cs_fn_DECRQKD};
CE cs_DECSPMA= {{"Session Page Memory Allocation", ENTRY_CS}, "DECSPMA", 1, {1},cs_fn_DECSPMA};
CE cs_DECUS  = {{"Update Session",           ENTRY_CS}, "DECUS", 1, {1},   cs_fn_DECUS};
CE cs_DECDLDA= {{"Down Line Load Allocation",ENTRY_CS}, "DECDLDA", 1, {1}, cs_fn_DECDLDA};
CE cs_DECSZS = {{"Select Zero Symbol",       ENTRY_CS}, "DECSZS", 1, {1},  cs_fn_DECSZS};
CE cs_DECAC  = {{"Assign Color",             ENTRY_CS}, "DECAC", 1, {1},   cs_fn_DECAC};
CE cs_DECATC = {{"Alternate Text Color",     ENTRY_CS}, "DECATC", 1, {1},  cs_fn_DECATC};
CE cs_DECPS  = {{"Play Sound",               ENTRY_CS}, "DECPS", 1, {1},   cs_fn_DECPS};

struct table_col CS_I12_7_DEC = {{
    &cs_DECLTOD.head, &cs_DECTID.head,  0,                0,
    0,                &cs_DECRQKT.head, &cs_DECRPKT.head, &cs_DECRQKD.head,
    &cs_DECSPMA.head, &cs_DECUS.head,   &cs_DECDLDA.head, &cs_DECSZS.head,
    &cs_DECAC.head,   &cs_DECATC.head,  &cs_DECPS.head,   0
}};

struct control_seq_final_table CS_I12 = {{ 0, 0, 0, &CS_I12_7_DEC }};

/*
 * Intermediate Character 13, Final Character Cols 4 - 7
 */

/* No defined functions for Cols 4-6 */

/* Final Character Col 7 (DEC Private) */

CE cs_DECARR  = {{"Select Auto Repeat Rate", ENTRY_CS}, "DECARR",   1, {1}, cs_fn_DECARR};
CE cs_DECCRTST= {{"CRT Saver Timing",        ENTRY_CS}, "DECCRTST", 1, {1}, cs_fn_DECCRTST};
CE cs_DECSEST = {{"Energy Saver Timing",     ENTRY_CS}, "DECSEST",  1, {1}, cs_fn_DECSEST};

struct table_col CS_I13_7_DEC = {{
    &cs_DECARR.head, &cs_DECCRTST.head, &cs_DECSEST.head, 0,
    0,               0,                 0,                0,
    0,               0,                 0,                0,
    0,               0,                 0,                0
}};

struct control_seq_final_table CS_I13 = {{ 0, 0, 0, &CS_I13_7_DEC }};

/*
 * No Intermediate Character 14-15 functions
 */

/*
 * Full Control Sequence Table
 */

struct control_seq_table CS_Table = {
  &CS_NoI,
  { &CS_I0,  &CS_I1,  &CS_I2,  0,
    &CS_I4,  0,       &CS_I6,  &CS_I7,
    0,       &CS_I9,  &CS_I10, &CS_I11,
    &CS_I12, &CS_I13, 0,       0 }
};
