#ifndef TERMINAL_H
#define TERMINAL_H

typedef struct terminal Terminal;

enum {
  DIR_UP,
  DIR_DOWN,
  DIR_FORWARD,
  DIR_BACK
};

Terminal *Terminal_new(void);

void Terminal_init(Terminal *t);

void Terminal_clearScreen(Terminal *t);
void Terminal_clearTabs(Terminal *t);
void Terminal_defaultTabs(Terminal *t);
void Terminal_setTab(Terminal *t);
void Terminal_clearTab(Terminal *t);

void Terminal_bufferDump(Terminal *t);
void Terminal_setAutoWrap(Terminal *t, int mode);
void Terminal_scroll(Terminal *t, int lines);

void Terminal_carriageReturn(Terminal *t);
void Terminal_lineFeed(Terminal *t);
void Terminal_newLine(Terminal *t);
void Terminal_backspace(Terminal *t);
void Terminal_horizontalTab(Terminal *t, int count);
void Terminal_backTab(Terminal *t, int count);

void Terminal_cursorRel(Terminal *t, int direction, int count, int scroll);
void Terminal_cursorAbsH(Terminal *t, int column);
void Terminal_cursorAbsV(Terminal *t, int line);
void Terminal_cursorAbs(Terminal *t, int column, int line);

void Terminal_insertGraphic(Terminal *t, unsigned char code, int count);
void Terminal_putGraphic(Terminal *t, unsigned char code);

#endif
